<?php

namespace App\Console\Commands;

use App\OwnerAreaReport;
use App\OwnerPriceSystem;
use App\Services\LogService;
use Carbon\Carbon;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;

class CreateOwnerBillReport extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'createOwnerBillReport';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'create owner bill report';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * 1号生成账单确认，确认金额由人工填写 原始金额默认为：即时账单月记录金额+仓储计费与面积计算金额
     *
     * @return void
     */
    public function handle()
    {
        $year = (int)date('Y');
        $month = (int)date('m');
        if ($month == 1){
            $year--;
            $lastMonth = '12';
        }else $lastMonth = ($month-1) < 10 ? "0".($month-1) : ($month-1);
        $sql = "SELECT owner_id,SUM(IFNULL(work_fee,0)) AS work_fee,SUM(IFNULL(logistic_fee,0)) AS logistic_fee FROM owner_fee_details WHERE worked_at LIKE ? AND ((type = '发货' AND logistic_fee IS NOT NULL AND work_fee IS NOT NULL) OR (type <> '发货' AND work_fee IS NOT NULL))  GROUP BY owner_id";
        $billDetails = DB::select(DB::raw($sql),[$year."-".$lastMonth."%"]);

        $areas = OwnerAreaReport::query()->with(["ownerStoragePriceModel.timeUnit","ownerStoragePriceModel.taxRate"])->where("counting_month","like",$year."-".$lastMonth."%")->get();
        $map = [];
        $mapTax = [];
        foreach($areas as $area){
            $key = $area->owner_id."_".$area->counting_month;
            if (isset($map[$key])){
                if (!$area->ownerStoragePriceModel)continue;
                list($money,$taxFee) = app('OwnerStoragePriceModelService')
                    ->calculationAmount($area->ownerStoragePriceModel,$area->accounting_area,$area->owner_id,$area->counting_month);
                $map[$key] += $money;
                $mapTax[$key] += $taxFee;
            }else{
                if (!$area->ownerStoragePriceModel)continue;
                list($map[$key],$mapTax[$key]) = app('OwnerStoragePriceModelService')
                    ->calculationAmount($area->ownerStoragePriceModel,$area->accounting_area,$area->owner_id,$area->counting_month);
            }
        }
        foreach (OwnerPriceSystem::query()->with(["timeUnit","taxRate"])->select("owner_id","usage_fee")->whereNull("operation")->orWhere("operation","")->get() as $system){
            list($systemFee[$system->owner_id],$systemTaxFee[$system->owner_id]) = $this->systemFee($system,$year."-".$lastMonth);
        }
        $chunks = array_chunk($billDetails,50);
        foreach ($chunks as $bills){
            $date = date('Y-m-d H:i:s');
            $createOwnerBillReport = [];
            foreach ($bills as $bill){
                $key = $bill->owner_id."_".$year."-".$lastMonth;
                $createOwnerBillReport[] = [
                    "owner_id"          => $bill->owner_id,       //项目ID
                    "counting_month"    => $year."-".$lastMonth."-01", //结算月
                    "work_fee"          => $bill->work_fee,
                    "logistic_fee"      => $bill->logistic_fee,
                    "storage_fee"       => $map[$key] ?? 0,
                    "storage_tax_fee"   => $mapTax[$key] ?? 0,
                    "other_fee"         => $systemFee[$bill->owner_id] ?? null,
                    "other_tax_fee"     => $systemTaxFee[$bill->owner_id] ?? null,
                    "created_at"        => $date,
                ];
            }
            LogService::log(__METHOD__,"项目管理-生成确认账单",json_encode($createOwnerBillReport));
            DB::table("owner_bill_reports")->insert($createOwnerBillReport);
        }
    }

    /**
     * 系统费用
     *
     * @param OwnerPriceSystem|\stdClass $system
     * @param string $month
     *
     * @return array
     */
    private function systemFee(OwnerPriceSystem $system,$month)
    {
        if (!$system->timeUnit)$money = $system->usage_fee;
        else{
            switch ($system->timeUnit->name){
                case "日":
                    $money = $system->usage_fee*(Carbon::parse($month)->lastOfMonth()->format("d"));
                    break;
                case "单":
                    $money = $system->usage_fee * (app("OrderService")->getOrderQuantity($system->owner_id));
                    break;
                case "年":
                    $money = $system->usage_fee/12;
                    break;
                default:
                    $money = $system->usage_fee;
            }
        }
        if ($system->taxRate)$taxFee = $money * ($system->taxRate->value/100);
        else{
            $system->load("owner.taxRate");
            if ($system->owner && $system->owner->taxRate)$taxFee = $money * ($system->owner->taxRate->value/100);
            else $taxFee = null;
        }
        return array($money,$taxFee);
    }
}
